#include "kernel.h"
#include "kernel_id.h"
#include "ecrobot_interface.h"
#include "lift.h"
#include "myrobot.h"


DeclareTask(Task1);				/* Task1を宣言 */

void ecrobot_device_initialize(){		/* OSEK起動時の処理（モータ停止）*/
	nxt_motor_set_speed(LIFT_MOTOR,0,0);
}

void ecrobot_device_terminate(){		/* OSEK終了時の処理（モータ停止）*/
	nxt_motor_set_speed(LIFT_MOTOR,0,0);
}

void user_1ms_isr_type2(void){}

void print_enc_data(){

	int enc_data;
	enc_data=nxt_motor_get_count(LIFT_MOTOR);

	//display_clear(0);
        display_goto_xy(0, 5);
        display_string("cur angle=");
        display_int(enc_data,1);
        display_update();
}


TASK(Task1)
{
	int count=0;


	nxt_motor_set_count(LIFT_MOTOR,0);		//ロータリエンコーダリセット 
	//nxt_motor_set_speed(LIFT_MOTOR,0,1);

	lift_init();
	systick_wait_ms(1000);

	lift_down(BASE_ANGLE);
	//lift_move_hold(BASE_ANGLE);
	print_enc_data();
	systick_wait_ms(2000);

	//nxt_motor_set_count(LIFT_MOTOR,90);		//ロータリエンコーダリセット 
	//lift_up(HOLD_ANGLE);
	lift_move_hold(HOLD_ANGLE);
	print_enc_data();

	while(1){	
		lift_hold(HOLD_ANGLE);
		if(count > 200) break;
		count++;
		display_clear(0);
		print_enc_data();
		systick_wait_ms(CNTL_TIME);
	}

	lift_move_hold(BASE_ANGLE2);

	count=0;
	while(1){	
		lift_hold(BASE_ANGLE2);
		display_clear(0);
		print_enc_data();
		//if(count > 200) break;
		count++;
		systick_wait_ms(CNTL_TIME);

	}
	print_enc_data();

	//nxt_motor_set_speed(LIFT_MOTOR,0,0);

	//display_clear(0);
        display_goto_xy(0, 1);
        display_string("Program End !!");
        display_update();

		
	TerminateTask();					/* 処理終了 */
}


