#include "kernel.h"
#include "kernel_id.h"
#include "ecrobot_interface.h"
#include "myrobot.h"
#include "lift.h"

void line_trace(int DIST, int edge, int hold_value)
{

	//float coef= 4.2 * 3.14/180; // [cm]
	float coef= TIRE_RADIUS * 3.14/180; // エンコーダ値を走行距離に変換する係数
	int enc_r, enc_l;
	int speed=65;
	int speed_r, speed_l;
	float Kp = 0.07 ; //0.1; //0.2;
	float Kd = 0.03 ; //0.5; //1.0;
	int light_edge;
	float dist;
	float turn=0;
	int light;
	int light_prev;

	light_edge = (BLACK + WHITE)/2;

	nxt_motor_set_count(R_MOTOR,0);		/* ロータリエンコーダリセット */	
	nxt_motor_set_count(L_MOTOR,0);		/* ロータリエンコーダリセット */	
	light_prev = ecrobot_get_light_sensor(PORT_LIGHT);

	if(hold_value > 0){
		lift_error_reset();
	}

	while(1){
		light = ecrobot_get_light_sensor(PORT_LIGHT);

		//左エッジ
		if(edge == 0){
			turn = Kp*(float)(light - light_edge) + Kd*(light - light_prev);
		}
		//右エッジ
		if(edge == 1){
			turn = -Kp*(float)(light - light_edge) - Kd*(light - light_prev);
		}

		enc_r = nxt_motor_get_count(R_MOTOR);
		enc_l = nxt_motor_get_count(L_MOTOR);	
		dist = (enc_r + enc_l)/2. *coef;
		if(dist > DIST) break;

		if(hold_value > 0){
			lift_hold(hold_value);
		}

		display_clear(0);
		display_goto_xy(0,2);
		display_string("turn=");
		display_int(turn,1);
		display_goto_xy(0,3);
		display_string("dist=");
		display_int(dist,1);
		display_update();

		//turn=0;
		speed_r =  speed + turn;
		speed_l =  speed - turn;

		nxt_motor_set_speed(R_MOTOR,speed_r,0);	
		nxt_motor_set_speed(L_MOTOR,speed_l,0);
		light_prev=light;

		systick_wait_ms(CNTL_TIME);
	}

	nxt_motor_set_speed(R_MOTOR,0,1);
	nxt_motor_set_speed(L_MOTOR,0,1);

}
