#include "kernel.h"
#include "kernel_id.h"
#include "ecrobot_interface.h"
#include "myrobot.h"

DeclareTask(Task1);				/* Task1を宣言 */

#define DIST 20						/* 角度指定のマクロ */

void ecrobot_device_initialize(){		/* OSEK起動時の処理（モータ停止）*/
	nxt_motor_set_speed(R_MOTOR,0,0);
	nxt_motor_set_speed(L_MOTOR,0,0);
	ecrobot_set_light_sensor_active(PORT_LIGHT);
}

void ecrobot_device_terminate(){		/* OSEK終了時の処理（モータ停止）*/
	nxt_motor_set_speed(R_MOTOR,0,0);
	nxt_motor_set_speed(L_MOTOR,0,0);
	ecrobot_set_light_sensor_inactive(PORT_LIGHT);	
}

void user_1ms_isr_type2(void){}

TASK(Task1)
{

	//float coef= 4.2 * 3.14/180; // [cm]
	float coef= TIRE_RADIUS * 3.14/180; // [cm]
	int enc_r, enc_l;
	int speed=65;
	int speed_r, speed_l;
	float Kp = 0.1;
	float Kd = 0.5;
	int light_edge;
	float dist;
	float turn;
	int light;
	int light_prev;

	light_edge = (BLACK + WHITE)/2;

	nxt_motor_set_count(R_MOTOR,0);		/* ロータリエンコーダリセット */	
	nxt_motor_set_count(L_MOTOR,0);		/* ロータリエンコーダリセット */	
	light_prev = ecrobot_get_light_sensor(PORT_LIGHT);

	while(1){
		light = ecrobot_get_light_sensor(PORT_LIGHT);
		turn = Kp*(float)(light - light_edge) + Kd*(light - light_prev);

		enc_r = nxt_motor_get_count(R_MOTOR);
		enc_l = nxt_motor_get_count(L_MOTOR);	
		dist = (enc_r + enc_l)/2. *coef;
		if(dist > DIST) break;

		display_clear(0);
		display_goto_xy(0,2);
		display_string("turn=");
		display_int(turn,1);
		display_goto_xy(0,3);
		display_string("dist=");
		display_int(dist,1);
		display_update();

		//turn=0;
		speed_r =  speed + turn;
		speed_l =  speed - turn;

		nxt_motor_set_speed(R_MOTOR,speed_r,0);	
		nxt_motor_set_speed(L_MOTOR,speed_l,0);
		light_prev=light;

		systick_wait_ms(CNTL_TIME);
	}

	nxt_motor_set_speed(R_MOTOR,0,1);
	nxt_motor_set_speed(L_MOTOR,0,1);

   	display_string("THAT'S ALL !");		/* メッセージを表示する */
	display_update();
	TerminateTask();					/* 処理終了 */
}
