#include "kernel.h"
#include "kernel_id.h"
#include "ecrobot_interface.h"
#include "myrobot.h"
#include "lift.h"
#include "run.h"


DeclareTask(Task1);			

void ecrobot_device_initialize(){
	nxt_motor_set_speed(R_MOTOR,0,0);
	nxt_motor_set_speed(L_MOTOR,0,0);
	nxt_motor_set_speed(LIFT_MOTOR,0,0);
	ecrobot_set_light_sensor_active(PORT_LIGHT);
}

void ecrobot_device_terminate(){	
	nxt_motor_set_speed(R_MOTOR,0,0);
	nxt_motor_set_speed(L_MOTOR,0,0);
	nxt_motor_set_speed(LIFT_MOTOR,0,0);
	ecrobot_set_light_sensor_inactive(PORT_LIGHT);
}

void user_1ms_isr_type2(void){}

void print_enc_data(){

	int enc_data;
	enc_data=nxt_motor_get_count(LIFT_MOTOR);

	//display_clear(0);
        display_goto_xy(0, 5);
        display_string("cur angle=");
        display_int(enc_data,1);
        display_update();
}

TASK(Task1)
{
	//int count=0;

	nxt_motor_set_count(LIFT_MOTOR,0);	


	//リフトを初期位置にセットする
	lift_init();
	systick_wait_ms(STOP_TIME);

	//エッジライントレース
	line_trace(40+1-6,1,0); //右
	straight(6,0);  // 6cm のみ直進走行
	systick_wait_ms(STOP_TIME);

	//右回転し、ガイドラインが見つかったところで止まる
	rotate_light(-90,0);
	systick_wait_ms(STOP_TIME);

	//リフトを下ろす
	lift_down(BASE_ANGLE);
	print_enc_data();
	systick_wait_ms(STOP_TIME);
	
	//左エッジのライントレースして修復材置き場へ向かう
	line_trace(12,0,0);
	systick_wait_ms(STOP_TIME);

	//修復材を持ち上げる
	lift_move_hold(HOLD_ANGLE);
	//print_enc_data();
	lift_hold_time(HOLD_ANGLE,STOP_TIME);

	//下がる
	straight(-12,HOLD_ANGLE);
	lift_hold_time(HOLD_ANGLE,STOP_TIME);

	//左回転しトレースラインに復帰する
	rotate_light(90,HOLD_ANGLE);
	lift_hold_time(HOLD_ANGLE,STOP_TIME);

	//右エッジのライントレース
	line_trace(32-6,1,HOLD_ANGLE);
	straight(6,HOLD_ANGLE);  // 6cm のみ直進走行
	lift_hold_time(HOLD_ANGLE,STOP_TIME);

	//右回転し、ガイドラインが見つかったところで止まる
	rotate_light(-90,HOLD_ANGLE);
	lift_hold_time(HOLD_ANGLE,STOP_TIME);

	//左エッジのライントレースで陸橋の修復位置に接近する
	line_trace(31-2,0,HOLD_ANGLE);
	lift_hold_time(HOLD_ANGLE,STOP_TIME);

	//修復材を下ろす
	lift_move_hold(BASE_ANGLE2);
	systick_wait_ms(STOP_TIME);

	//後退する
	straight(-25,0);
	systick_wait_ms(STOP_TIME);

	//リフトを元の位置に戻す
	lift_init();
	systick_wait_ms(STOP_TIME);

	display_clear(0);
        display_goto_xy(0, 1);
        display_string("Program End !!");
        display_update();

		
	TerminateTask();
}


