#include "kernel.h"
#include "kernel_id.h"
#include "ecrobot_interface.h"
#include "myrobot.h"
#include "lift.h"

void rotate(int ANGLE, int hold_value)
{

	//float coef= 4.2 / 14.8; // [deg]
	float coef= TIRE_RADIUS / TIRE_DIST ; //エンコーダ値を車体回転角に変換する係数
	float angle;
	int enc_r, enc_l;
	int speed=65;
	int speed_r, speed_l;
	float Kp = 0.2;

	nxt_motor_set_count(R_MOTOR,0);		/* ロータリエンコーダリセット */	
	nxt_motor_set_count(L_MOTOR,0);		/* ロータリエンコーダリセット */	

        if(hold_value > 0){
                lift_error_reset();
        }

        if(ANGLE < 0){
                speed *= -1;
        }

	while(1){
		enc_r = nxt_motor_get_count(R_MOTOR);
		enc_l = nxt_motor_get_count(L_MOTOR);	

		angle = (enc_r - enc_l) *coef;
		//if(angle > ANGLE) break;
                if(ANGLE > 0){
                        if(angle > ANGLE) break;
                }else{
                        if(-angle > -ANGLE) break;
                }

		//nxt_motor_set_speed(R_MOTOR,speed,0);	
		//nxt_motor_set_speed(L_MOTOR,-speed,0);		
		speed_r =  speed - Kp*(enc_r + enc_l);
		speed_l = -speed - Kp*(enc_r + enc_l);
		nxt_motor_set_speed(R_MOTOR,speed_r,0);	
		nxt_motor_set_speed(L_MOTOR,speed_l,0);

                if(hold_value > 0){
                        lift_hold(hold_value);
                }

		systick_wait_ms(CNTL_TIME);
	}

	nxt_motor_set_speed(R_MOTOR,0,1);
	nxt_motor_set_speed(L_MOTOR,0,1);

}

void rotate_light(int ANGLE, int hold_value)
{

	//float coef= 4.2 / 14.8; // [deg]
	float coef= TIRE_RADIUS / TIRE_DIST; // [deg]
	float angle;
	int enc_r, enc_l;
	int speed=65;
	int speed_r, speed_l;
	float Kp = 0.2;
	int light;
	int light_edge; 

	light_edge = (BLACK + WHITE)/2;


	nxt_motor_set_count(R_MOTOR,0);		/* ロータリエンコーダリセット */	
	nxt_motor_set_count(L_MOTOR,0);		/* ロータリエンコーダリセット */	

        if(hold_value > 0){
                lift_error_reset();
        }

        if(ANGLE < 0){
                speed *= -1;
        }

	while(1){
		enc_r = nxt_motor_get_count(R_MOTOR);
		enc_l = nxt_motor_get_count(L_MOTOR);	

		light = ecrobot_get_light_sensor(PORT_LIGHT);


		angle = (enc_r - enc_l) *coef;

		
                if(ANGLE > 0){
			//if( angle > ANGLE*2/3){
			if( angle > ANGLE/2){
				if(light > light_edge - 20  && light < light_edge + 20) break; 
			}
		}else{
			//if( -angle > -ANGLE*2/3){
			if( -angle > -ANGLE/2){
				if(light > light_edge -20  && light < light_edge + 20) break; 
			}

		}


		//nxt_motor_set_speed(R_MOTOR,speed,0);	
		//nxt_motor_set_speed(L_MOTOR,-speed,0);		
		speed_r =  speed - Kp*(enc_r + enc_l);
		speed_l = -speed - Kp*(enc_r + enc_l);
		nxt_motor_set_speed(R_MOTOR,speed_r,0);	
		nxt_motor_set_speed(L_MOTOR,speed_l,0);

                if(hold_value > 0){
                        lift_hold(hold_value);
                }

		systick_wait_ms(CNTL_TIME);
	}

	nxt_motor_set_speed(R_MOTOR,0,1);
	nxt_motor_set_speed(L_MOTOR,0,1);

}
