#include "kernel.h"
#include "kernel_id.h"
#include "ecrobot_interface.h"
#include "myrobot.h"


DeclareTask(Task1);				/* Task1を宣言 */

void ecrobot_device_initialize(){		/* OSEK起動時の処理（モータ停止）*/
	nxt_motor_set_speed(R_MOTOR,0,0);
	nxt_motor_set_speed(L_MOTOR,0,0);
}

void ecrobot_device_terminate(){		/* OSEK終了時の処理（モータ停止）*/
	nxt_motor_set_speed(R_MOTOR,0,0);
	nxt_motor_set_speed(L_MOTOR,0,0);
}

void user_1ms_isr_type2(void){}

#define ANGLE -90						/* 角度指定のマクロ */


TASK(Task1)
{

	//float coef= 4.2 / 14.8; // [deg]
	float coef= TIRE_RADIUS / TIRE_DIST; 
	float angle;
	int enc_r, enc_l;
	int speed=65;
	int speed_r, speed_l;
	float Kp = 0.2;

	nxt_motor_set_count(R_MOTOR,0);		/* ロータリエンコーダリセット */	
	nxt_motor_set_count(L_MOTOR,0);		/* ロータリエンコーダリセット */	

	if(ANGLE < 0){
		speed *= -1;
	}

	while(1){
		enc_r = nxt_motor_get_count(R_MOTOR);
		enc_l = nxt_motor_get_count(L_MOTOR);	
		angle = (enc_r - enc_l) *coef;
		//if(angle > ANGLE) break;
		if(ANGLE > 0){
			if(angle > ANGLE) break;
		}else{
			if(-angle > -ANGLE) break;
		}
		//nxt_motor_set_speed(R_MOTOR,speed,0);	
		//nxt_motor_set_speed(L_MOTOR,-speed,0);		
		speed_r =  speed - Kp*(enc_r + enc_l);
		speed_l = -speed - Kp*(enc_r + enc_l);
		nxt_motor_set_speed(R_MOTOR,speed_r,0);	
		nxt_motor_set_speed(L_MOTOR,speed_l,0);
		systick_wait_ms(CNTL_TIME);
	}

	nxt_motor_set_speed(R_MOTOR,0,1);
	nxt_motor_set_speed(L_MOTOR,0,1);

   	display_string("THAT'S ALL !");		/* メッセージを表示する */
	display_update();
	TerminateTask();					/* 処理終了 */
}
