#include "kernel.h"
#include "kernel_id.h"
#include "ecrobot_interface.h"
#include "myrobot.h"


DeclareTask(Task1);				/* Task1を宣言 */

void ecrobot_device_initialize(){		/* OSEK起動時の処理（モータ停止）*/
	nxt_motor_set_speed(R_MOTOR,0,0);
	nxt_motor_set_speed(L_MOTOR,0,0);
}

void ecrobot_device_terminate(){		/* OSEK終了時の処理（モータ停止）*/
	nxt_motor_set_speed(R_MOTOR,0,0);
	nxt_motor_set_speed(L_MOTOR,0,0);
}

void user_1ms_isr_type2(void){}

#define DIST -20						/* 角度指定のマクロ */


TASK(Task1)
{

	float coef= TIRE_RADIUS * 3.14/180; // [cm]
	//float coef= 4.2 * 3.14/180; // [cm]
	float dist;
	int enc_r, enc_l;
	int speed=65;
	int speed_r, speed_l;
	float Kp = 0.2;
	float Kd = 1.0;
	int enc_diff;
	int enc_diff_prev=0;
	int turn;

	nxt_motor_set_count(R_MOTOR,0);		/* ロータリエンコーダリセット */	
	nxt_motor_set_count(L_MOTOR,0);		/* ロータリエンコーダリセット */	

	if(DIST<0){
		speed *= -1;
	}

	while(1){
		enc_r = nxt_motor_get_count(R_MOTOR);
		enc_l = nxt_motor_get_count(L_MOTOR);	
		dist = (enc_r + enc_l)/2. *coef;
		enc_diff = enc_r - enc_l;
		if(DIST>0){
			if(dist > DIST) break;
		}else{
			if(-dist > -DIST) break;
		}
		turn = Kp*enc_diff + Kd*enc_diff_prev;
		speed_r =  speed - turn;
		speed_l =  speed + turn;
		nxt_motor_set_speed(R_MOTOR,speed_r,0);	
		nxt_motor_set_speed(L_MOTOR,speed_l,0);
		enc_diff_prev=enc_diff;
		systick_wait_ms(CNTL_TIME);
	}

	nxt_motor_set_speed(R_MOTOR,0,1);
	nxt_motor_set_speed(L_MOTOR,0,1);

   	display_string("THAT'S ALL !");		/* メッセージを表示する */
	display_update();
	TerminateTask();					/* 処理終了 */
}
